<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="utf-8">
    <title>uWeaver UI - API documentation : Source: widget/Widget.js</title>

    <script src="scripts/prettify/prettify.js"> </script>
    <script src="scripts/prettify/lang-css.js"> </script>
    <!--[if lt IE 9]>
      <script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
    <![endif]-->
    <link type="text/css" rel="stylesheet" href="styles/prettify-tomorrow.css">
    <link href="styles/bootstrap.css" rel="stylesheet">
    <link href="styles/docs.css" rel="stylesheet">
    <link href="styles/bootstrap-custom.css" rel="stylesheet">
    <link href="http://netdna.bootstrapcdn.com/font-awesome/3.2.1/css/font-awesome.css" rel="stylesheet">
    <script src="http://netdna.bootstrapcdn.com/twitter-bootstrap/2.3.2/js/bootstrap.min.js"></script>
  </head>
  <body>
    <header class="header navbar navbar-inverse">
      <div class="navbar-inner">
        <div class="container-fluid">
          <a class="brand" href="#"><strong>uWeaver UI</strong> API documentation</a>
        </div>
      </div>
    </header>

    <div class="container-fluid">
      <div class="row-fluid">
          <div class="span4">
              <h2><a href="index.html">Index</a></h2><div class="well well-small"><ul class="nav nav-list"><li class="nav-header">Modules</li><li><a href="module-boolean.html">boolean</a></li>
<li><a href="module-datetime.html">datetime</a></li>
<li><a href="module-dom.html">dom</a></li>
<li><a href="module-environment.html">environment</a></li>
<li><a href="module-formatter.html">formatter</a></li>
<li><a href="module-i18n.html">i18n</a></li>
<li><a href="module-lang.html">lang</a></li>
<li><a href="module-net.html">net</a></li>
<li><a href="module-number.html">number</a></li>
<li><a href="module-uweaver.html">uweaver</a></li></ul></div><div class="well well-small"><ul class="nav nav-list"><li class="nav-header">Classes</li><li><a href="Activities.html"><i class="icon-shield" style="color: #0186d1"></i> Activities</a></li><li><a href="Activity.html"><i class="icon-shield" style="color: #0186d1"></i> Activity</a></li><li><a href="Applet.html"><i class="icon-shield" style="color: #0186d1"></i> Applet</a></li><li><a href="BaseObject.html"><i class="icon-shield" style="color: #0186d1"></i> BaseObject</a></li><li><a href="Button.html"><i class="icon-shield" style="color: #0186d1"></i> Button</a></li><li><a href="CartesianChart.html"><i class="icon-shield" style="color: #0186d1"></i> CartesianChart</a></li><li><a href="Checkbox.html"><i class="icon-shield" style="color: #0186d1"></i> Checkbox</a></li><li><a href="Collection.html"><i class="icon-shield" style="color: #0186d1"></i> Collection</a></li><li><a href="Combobox.html"><i class="icon-shield" style="color: #0186d1"></i> Combobox</a></li><li><a href="Container.html"><i class="icon-shield" style="color: #0186d1"></i> Container</a></li><li><a href="Datebox.html"><i class="icon-shield" style="color: #0186d1"></i> Datebox</a></li><li><a href="Datepicker.html"><i class="icon-shield" style="color: #0186d1"></i> Datepicker</a></li><li><a href="Filebox.html"><i class="icon-shield" style="color: #0186d1"></i> Filebox</a></li><li><a href="Filedropper.html"><i class="icon-shield" style="color: #0186d1"></i> Filedropper</a></li><li><a href="Form.html"><i class="icon-shield" style="color: #0186d1"></i> Form</a></li><li><a href="Gadget.html"><i class="icon-shield" style="color: #0186d1"></i> Gadget</a></li><li><a href="Grid.html"><i class="icon-shield" style="color: #0186d1"></i> Grid</a></li><li><a href="Icon.html"><i class="icon-shield" style="color: #0186d1"></i> Icon</a></li><li><a href="Inputbox.html"><i class="icon-shield" style="color: #0186d1"></i> Inputbox</a></li><li><a href="Item.html"><i class="icon-shield" style="color: #0186d1"></i> Item</a></li><li><a href="Json.html"><i class="icon-shield" style="color: #0186d1"></i> Json</a></li><li><a href="Logger.html"><i class="icon-shield" style="color: #0186d1"></i> Logger</a></li><li><a href="MDIApplet.html"><i class="icon-shield" style="color: #0186d1"></i> MDIApplet</a></li><li><a href="Memory.html"><i class="icon-shield" style="color: #0186d1"></i> Memory</a></li><li><a href="Menu.html"><i class="icon-shield" style="color: #0186d1"></i> Menu</a></li><li><a href="Model.html"><i class="icon-shield" style="color: #0186d1"></i> Model</a></li><li><a href="Numberbox.html"><i class="icon-shield" style="color: #0186d1"></i> Numberbox</a></li><li><a href="Pagination.html"><i class="icon-shield" style="color: #0186d1"></i> Pagination</a></li><li><a href="Panel.html"><i class="icon-shield" style="color: #0186d1"></i> Panel</a></li><li><a href="PolarChart.html"><i class="icon-shield" style="color: #0186d1"></i> PolarChart</a></li><li><a href="Popup.html"><i class="icon-shield" style="color: #0186d1"></i> Popup</a></li><li><a href="Portal.html"><i class="icon-shield" style="color: #0186d1"></i> Portal</a></li><li><a href="Proxy.html"><i class="icon-shield" style="color: #0186d1"></i> Proxy</a></li><li><a href="Radiobutton.html"><i class="icon-shield" style="color: #0186d1"></i> Radiobutton</a></li><li><a href="Reader.html"><i class="icon-shield" style="color: #0186d1"></i> Reader</a></li><li><a href="Selectbox.html"><i class="icon-shield" style="color: #0186d1"></i> Selectbox</a></li><li><a href="Site.html"><i class="icon-shield" style="color: #0186d1"></i> Site</a></li><li><a href="Sites.html"><i class="icon-shield" style="color: #0186d1"></i> Sites</a></li><li><a href="Store.html"><i class="icon-shield" style="color: #0186d1"></i> Store</a></li><li><a href="TabPanel.html"><i class="icon-shield" style="color: #0186d1"></i> TabPanel</a></li><li><a href="TDIApplet.html"><i class="icon-shield" style="color: #0186d1"></i> TDIApplet</a></li><li><a href="Testbench.html"><i class="icon-shield" style="color: #0186d1"></i> Testbench</a></li><li><a href="Testlet.html"><i class="icon-shield" style="color: #0186d1"></i> Testlet</a></li><li><a href="Textbox.html"><i class="icon-shield" style="color: #0186d1"></i> Textbox</a></li><li><a href="Toolbox.html"><i class="icon-shield" style="color: #0186d1"></i> Toolbox</a></li><li><a href="Trigger.html"><i class="icon-shield" style="color: #0186d1"></i> Trigger</a></li><li><a href="Triggers.html"><i class="icon-shield" style="color: #0186d1"></i> Triggers</a></li><li><a href="User.html"><i class="icon-shield" style="color: #0186d1"></i> User</a></li><li><a href="Users.html"><i class="icon-shield" style="color: #0186d1"></i> Users</a></li><li><a href="Violation.html"><i class="icon-shield" style="color: #0186d1"></i> Violation</a></li><li><a href="Widget.html"><i class="icon-shield" style="color: #0186d1"></i> Widget</a></li><li><a href="WindowManager.html"><i class="icon-shield" style="color: #0186d1"></i> WindowManager</a></li><li><a href="Workbench.html"><i class="icon-shield" style="color: #0186d1"></i> Workbench</a></li></ul></div><div class="well well-small"><ul class="nav nav-list"><li class="nav-header">Global</li><li><a href="global.html#_anchors"><i class="icon-globe" style="color: black;"></i> _anchors</a></li><li><a href="global.html#_form"><i class="icon-globe" style="color: black;"></i> _form</a></li><li><a href="global.html#_interact"><i class="icon-globe" style="color: black;"></i> _interact</a></li><li><a href="global.html#_marker"><i class="icon-globe" style="color: black;"></i> _marker</a></li><li><a href="global.html#_tabPanel"><i class="icon-globe" style="color: black;"></i> _tabPanel</a></li><li><a href="global.html#browse"><i class="icon-globe" style="color: black;"></i> browse</a></li><li><a href="global.html#draggable"><i class="icon-globe" style="color: black;"></i> draggable</a></li><li><a href="global.html#events"><i class="icon-globe" style="color: black;"></i> events</a></li><li><a href="global.html#initialize"><i class="icon-globe" style="color: black;"></i> initialize</a></li><li><a href="global.html#layout"><i class="icon-globe" style="color: black;"></i> layout</a></li><li><a href="global.html#logger"><i class="icon-globe" style="color: black;"></i> logger</a></li><li><a href="global.html#login"><i class="icon-globe" style="color: black;"></i> login</a></li><li><a href="global.html#onDragstart"><i class="icon-globe" style="color: black;"></i> onDragstart</a></li><li><a href="global.html#onTabsActivate"><i class="icon-globe" style="color: black;"></i> onTabsActivate</a></li><li><a href="global.html#onTaskSelect"><i class="icon-globe" style="color: black;"></i> onTaskSelect</a></li><li><a href="global.html#perform"><i class="icon-globe" style="color: black;"></i> perform</a></li><li><a href="global.html#prepare"><i class="icon-globe" style="color: black;"></i> prepare</a></li><li><a href="global.html#requirejs"><i class="icon-globe" style="color: black;"></i> requirejs</a></li><li><a href="global.html#start"><i class="icon-globe" style="color: black;"></i> start</a></li><li><a href="global.html#toUrl"><i class="icon-globe" style="color: black;"></i> toUrl</a></li><li><a href="global.html#validate"><i class="icon-globe" style="color: black;"></i> validate</a></li></ul></div>
          </div>

          <div class="span8">
              <h1 class="page-header">Source: widget/Widget.js</h1>
              


    
    <section>
        <article>
            <pre class="prettyprint source"><code>/**
 * @license
 * This document is a part of the source code and related artifacts
 * for uWeaver, an open source application development framework for
 * Enterprise Application Software.
 *
 *      http://www.uweaver.org
 *
 * Copyright 2014 Jason Lin
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

define(['backbone', 'underscore',  'jquery', 'uweaver/lang'], function(Backbone, _, $, lang) {
    var declare = lang.declare;
    var Base = Backbone.View;

    /**
     * A class representing an user interface components.
     *
     * The widget use html template to layout &amp; construct the DOM element.
     *
     * ##### Events:
     * + 'render' - [render()]{@link Widget#render}
     * + 'attach' - [attach()]{@link Widget#attach}
     * + 'detach' - [detach()]{@link Widget#detach}
     * + 'destroy' - [destroy()]{@link Widget#destroy}
     *
     * @constructor Widget
     * @extends Backbone.View
     * @author  Jason Lin
     * @since   1.0
     * @param {Object} [config] - A map of configuration to pass to the constructor.
     * ##### Options:
     * + tpl(String) - A html string to layout &amp; construct the DOM element.
     */
    function initialize(config) {
        var defaults = {
            tpl: undefined
        };

        config || (config = {});

        this._cfg = config;
        this._anchors = {};

        _.defaults(this._cfg, defaults);

        this._oid = _.uniqueId();

        this.prop('id') || (this.prop('id', this._oid))
    }

    /**
     * Render the widget.
     *
     * This method compiles the template to generate the html, then construct the DOM element from html.
     *
     * @memberof Widget#
     * @protected
     * @param {Object} [options] - Rendering options.
     * @param {Boolean} [options.hidden=false] - A boolean value to specify the visibility after rendered.
     * @returns {Widget} this.
     */
    function render(options) {
        var defaults = {
            hidden: false
        };
        var cfg = this._cfg;

        options || (options = {});
        _.defaults(options, defaults);

        this.hide();

        
        if(this.el &amp;&amp; this.$el.html().trim().length==0 &amp;&amp; cfg.tpl) {
            this.$el.html(_.template(cfg.tpl)(this));
        }


        if(this.render === render) {
            this._isRendered = true;

            this.trigger('render', {
                data: {},
                context: this,
                source: this
            });
            options.hidden || this.show();
        }

        return this;
    }

    /**
     * Get or set the value of the config.
     *
     * @memberof Widget#
     * @returns {Object} the config.
     */
    function cfg() {
        return this._cfg;
    }

    function oid() {
        return this._oid;
    }

    /**
     * Get or set the value of a style property.
     *
     * @memberof Widget#
     * @param {Object} name - The css property name.
     * @param {Object} [value] - A value to set for the property.
     * @returns {Object} css style.
     */
    function css(name, value) {
        var $node = this.$el;
        return $node.css.apply($node, arguments);
    }

    /**
     * Get or set the value of an attribute.
     *
     * @memberof Widget#
     * @param {String} name - The name of the attribute.
     * @param {Object} [value] - A value to set for the attribute.
     * @returns {*} the value of the attribute.
     */
    function attr(name, value) {
        var $node = this.$el;
        return $node.attr.apply($node, arguments);
    }

    /**
     * Get or set the value of a property.
     *
     * @memberof Widget#
     * @param {String} name - The name of the property.
     * @param {Object} [value] - A value to set for the property.
     * @returns {*} The value of the property.
     */
    function prop(name, value) {
        var $node = this.$el;
        return $node.prop.apply($node, arguments);
    }

    /**
     * Add the specified class(es) to the widget.
     *
     * @memberof Widget#
     * @param {String} classNames - One or more space-separated classes to be added.
     * @returns {Widget} this
     */
    function addClass(classNames) {
        var $node = this.$el;
        $node.addClass.apply($node, arguments);
        return this;
    }

    /**
     * Remove the specified class(es) from the widget.
     *
     * @memberof Widget#
     * @param {String} names - One or more space-separated classes to be removed.
     * @returns {Widget} this
     */
    function removeClass(names) {
        var $node = this.$el;
        $node.removeClass.apply($node, arguments);
        return this;
    }

    /**
     * Determine whether the widget are assigned the given class.
     *
     * @memberof Widget#
     * @param {String} name - The class name to search for.
     * @returns {Boolean}
     */
    function hasClass() {
        var $node = this.$el;
        return $node.hasClass.apply($node, arguments);
    }

    /**
     * Display the widget.
     *
     * @memberof Widget#
     * @param {Object} [options] - A map of additional options to pass to the method.
     * See [jQuery.show(options)](https://api.jquery.com/show/) for details.
     * @returns {Widget} this
     */
    function show(options) {
        var $node = this.$el;
        $node.show.apply($node, arguments);

        this.trigger('show', {
            data: {},
            context: this,
            source: this
        });

        return this;
    }

    /**
     * Hide the widget.
     *
     * @memberof Widget#
     * @param {Object} [options] - A map of additional options to pass to the method.
     * See [jQuery.hide(options)](https://api.jquery.com/hide/) for details.
     * @returns {Widget} this
     */
    function hide() {
        var $node = this.$el;
        $node.hide.apply($node, arguments);

        this.trigger('hide', {
            data: {},
            context: this,
            source: this
        });

        return this;
    }

    /**
     * Display or hide the widget.
     *
     * @memberof Widget#
     * @param {Object} [options] - A map of additional options to pass to the method.
     * See [jQuery.toggle(options)](https://api.jquery.com/toggle/) for details.
     * @returns {Widget} this
     */
    function toggle() {
        var $node = this.$el;
        $node.toggle.apply($node, arguments);
        return this;
    }

    function isVisible() {
        var $node = this.$el;
        return $node.is(":visible");
    }

    function isAttached() {
        return document.contains(this.el);
    }

    function isRendered() {
        return this._isRendered;
    }
    /**
     * Attach the widget to the DOM element.
     *
     * ##### Events:
     * + 'attach' - triggered after attach.
     *
     * @memberof Widget#
     * @param {Widget|jQuery|Element} component - specify the component to which this widget is attached.
     * @param {Object} [options] - A map of additional options to pass to the method.
     * #####Options
     * + {Boolean} prepend - Attach the widget to the begin of the element. Default: false.
     * @returns {Widget}
     */
    function attach(component, options) {
        options || (options = {});

        var $element;

        if(component instanceof Widget) {
            $element = component.$el;
        } else if(component instanceof jQuery) {
            $element = component;
        } else if(component instanceof Element) {
            $element = $(component);
        } else {
            throw new UnsupportedTypeException({
                supportedTypes: ['Widget', 'jQuery', 'Element'],
                type: typeof component
            });
        }

        if(options.prepend) {
            this.$el.prependTo($element);
        } else {
            this.$el.appendTo($element);
        }

        this.trigger('attach', {
            data: {},
            context: this,
            source: this
        });

        return this;
    }

    /**
     * Detach the widget from the DOM.
     *
     * ##### Events:
     * + 'detached' - triggered after detach.
     *
     * The method removes the widget from the DOM but keeps all data associated with the removed widget.
     * This method is useful when removed widget is to be reinserted into the DOM at a later time.
     *
     * @memberof Widget#
     * @return void
     */
    function detach() {
        this.$el.detach();
        this.trigger('detach', {
            data: {},
            context: this,
            source: this
        });
    }

    /**
     * Destroy the widget from the DOM.
     *
     * This method removes the widget from the DOM &amp; destroy the widget.
     * This method also remove the event handlers registered using .listenTo().
     *
     * ##### Events:
     * + 'destroy' - triggered before destroy.
     *
     * @memberof Widget#
     * @return void
     */
    function destroy() {
        this.trigger('destroy', {
            data: {},
            context: this,
            source: this
        });
        this.undelegateEvents();
        this.stopListening();
        this.remove();
    }

    /**
     * A helper method to find the specified DOM element within the widget.
     *
     * This method uses the data-uw-anchor attribute to locate the DOM element.
     *
     * @memberof Widget#
     * @param {String} name - The name of the anchor to search for.
     * @returns {Element}
     */
    function anchor(name) {
        return this.$("[data-uw-anchor=" + name + "]").first();
    }

    /**
     * A helper method to find the specified jQuery object within the widget.
     *
     * This method uses the data-uw-anchor attribute to locate the jQuery object.
     *
     * @memberof Widget#
     * @param {String} name - The name of the anchor to search for.
     * @returns {jQuery}
     */
    function $anchor(name) {
        return this.$("[data-uw-anchor=" + name + "]");
    }

    /**
     * A helper method to find the dom elements matched the selector.
     *
     * @memberof Widget#
     * @param {String} selector - css selector.
     * @returns {NodeList}
     */
    function query(selector) {
        return this.el.querySelectorAll(selector);
    }


    function width(value) {
        if(!value) return this.$el.width();

        this.$el.width(value);
    }


    function height(value) {
        if(!value) return this.$el.height();

        this.$el.height(value);
    }

    function innerWidth(value) {
        if(!value) return this.$el.innerWidth();

        this.$el.innerWidth(value);
    }


    function innerHeight(value) {
        if(!value) return this.$el.innerHeight();

        this.$el.innerHeight(value);
    }

    function outerWidth(value, includeMargin) {
        if(_.isBoolean(value)) {
            includeMargin = value;
            value = undefined;
        }
        if(!value) return this.$el.outerWidth(includeMargin);

        this.$el.outerWidth(value, includeMargin);
    }


    function outerHeight(value, includeMargin) {
        if(_.isBoolean(value)) {
            includeMargin = value;
            value = undefined;
        }
        if(!value) return this.$el.outerHeight(includeMargin);

        this.$el.outerHeight(value, includeMargin);
    }

    function left(value) {
        if(!value) return this.$el.position().left;

        this.$el.css({left: value});
    }

    function top(value) {
        if(!value) return this.$el.position().top;

        this.$el.css({top: value});
    }

    function moveTo(position) {
        if(position.right!==undefined) {
            position.left = 'auto';
        }
        this.css({top: position.top, left:position.left, right: position.right, position:'fixed'});

    }

    function toJSON() {
        return {
            class: this._class,
            oid: this._oid,
            tagName: this.tagName,
            className: this.className,
            html: this.$el.html()
        }
    }

    function disable() {
        this._availability = false;
    }

    function enable() {
        this._availability = true;
    }

    function isAvailable() {
        return this._availability;
    }

    var props = {
        /**
         * The initial configuration of the widget.
         *
         * @memberof Widget#
         * @protected
         * @type Object
         */
        _cfg: null,
        _class: 'Widget',
        _anchors: null,
        _oid: null,
        _availability: false,

        /**
         * The html tag name of the widget.
         *
         * @memberof Widget#
         * @protected
         * @type String
         * @default "div"
         */
        tagName: 'div'
    };

    var Widget = declare(Base, {
        initialize: initialize,
        cfg: cfg,
        oid: oid,
        css: css,
        prop: prop,
        attr: attr,
        height: height,
        innerHeight: innerHeight,
        outerHeight: outerHeight,
        width: width,
        innerWidth: innerWidth,
        outerWidth: outerWidth,
        moveTo: moveTo,
        toJSON: toJSON,


        addClass: addClass,
        removeClass: removeClass,
        hasClass: hasClass,
        show: show,
        hide: hide,
        enable: enable,
        disable: disable,
        toggle: toggle,
        isVisible: isVisible,
        isAvailable: isAvailable,
        isAttached: isAttached,
        attach: attach,
        detach: detach,
        destroy: destroy,
        anchor: anchor,
        $anchor: $anchor,
        query: query,
        render: render,
        isRendered: isRendered
    }, props);

    return Widget;

});</code></pre>
        </article>
    </section>




          </div>
      </div>

        <br clear="both">

      <footer>
        Documentation generated by <a href="https://github.com/jsdoc3/jsdoc">JSDoc 3.3.2</a> on Fri Aug 26 2016 10:58:19 GMT+0800 (CST)
        <br>
      </footer>
      <script> prettyPrint(); </script>
    </div>
  </body>
</html>
